%define anolis_release 1

Name:		smartmontools	
Version:	7.4
Release:	%{anolis_release}%{?dist}
Summary:	http://smartmontools.sourceforge.net/

License:	GPLv2+
URL:		http://smartmontools.sourceforge.net/
Source0:	https://sourceforge.net/projects/smartmontools/files/smartmontools/7.3/%{name}-%{version}.tar.gz
Source1:	smartmontools.sysconf
Source2:	smartdnotify
# https://sourceforge.net/p/smartmontools/code/HEAD/tree/trunk/smartmontools/drivedb.h?format=raw%20Source5:drivedb.h
Source3:	drivedb.h

# Refer to https://gitlab.com/redhat/centos-stream/rpms/smartmontools/-/commit/991ed6d19817dfae652607ba458639ad26d81ceb
Patch0001:      smartmontools-7.4-fix_sast.patch

BuildRequires:	make
BuildRequires:	gcc-c++ readline-devel ncurses-devel automake util-linux groff gettext
BuildRequires:	libselinux-devel libcap-ng-devel
BuildRequires:	systemd systemd-devel


%description
The smartmontools package contains two utility programs (smartctl
and smartd) to control and monitor storage systems using the Self-
Monitoring, Analysis and Reporting Technology System (SMART) built
into most modern ATA and SCSI hard disks. In many cases, these
utilities will provide advanced warning of disk degradation and
failure.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1
cp %{SOURCE3} ./

%build
autoreconf -i
%configure \
	--with-selinux \
	--with-libcap-ng=yes \
	--with-libsystemd \
	--with-systemdsystemunitdir=%{_unitdir} \
	--sysconfdir=%{_sysconfdir}/%{name}/ \
	--with-systemdenvfile=%{_sysconfdir}/sysconfig/%{name}

# update SOURCE5 on maintainer's machine prior commiting, there's no internet connection on builders
%make_build update-smart-drivedb
./update-smart-drivedb -s - -u sf drivedb.h ||:
cp drivedb.h ../drivedb.h ||:

%make_build CXXFLAGS="$RPM_OPT_FLAGS -fpie" LDFLAGS="-pie -Wl,-z,relro,-z,now"

%install
%make_install

rm -f examplescripts/Makefile*
chmod a-x -R examplescripts/*
install -D -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/smartmontools
install -D -p -m 755 %{SOURCE2} $RPM_BUILD_ROOT/%{_libexecdir}/%{name}/smartdnotify
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/smartd_warning.d
rm -rf $RPM_BUILD_ROOT/etc/{rc.d,init.d}
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_sharedstatedir}/%{name}

%generate_compatibility_deps

%preun
%systemd_preun smartd.service

%post
%systemd_post smartd.service

%postun
%systemd_postun_with_restart smartd.service

%files
%license COPYING
%doc examplescripts smartd.conf
%dir %{_sysconfdir}/%name
%dir %{_sysconfdir}/%name/smartd_warning.d
%dir %{abidir}
%config(noreplace) %{_sysconfdir}/%{name}/smartd.conf
%config(noreplace) %{_sysconfdir}/%{name}/smartd_warning.sh
%config(noreplace) %{_sysconfdir}/sysconfig/smartmontools
%{_unitdir}/smartd.service
%{_sbindir}/smartd
%{_sbindir}/update-smart-drivedb
%{_sbindir}/smartctl
%{abidir}/*-option.list
%{_mandir}/man?/smart*.*
%{_mandir}/man?/update-smart*.*
%{_libexecdir}/%{name}
%{_datadir}/%{name}
%{_sharedstatedir}/%{name}

%files doc
%doc AUTHORS ChangeLog INSTALL NEWS README TODO

%changelog
* Tue Feb 18 2025 Chang Gao <gc-taifu@linux.alibaba.com> - 7.4-1
- Update to 7.4
- Update drivedb.h and add patch to fix some bug
  [Patches cherry-picked from c10s. Original changelog:
  - fix static analysis findings (7.4-5)]

* Fri Oct 14 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 7.3-3
- optimise spec file

* Thu Oct 13 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 7.3-2
- add api & add doc package

* Mon Apr 18 2022 happy_orange <songnannan@linux.alibaba.com> - 7.3-1
- Init package from upstream
